<?php
/*
 * PDF Form Filler
 *
 * befllt PDF-Formulare mit dynamischen Werten
 *
 * @author Lars Wegmann info@wegmann-it.de
 * Created on 18.02.2008 15:21:19
 * 
 */


// fix: sichert abwrtskompatibilitt fr php 4 Umgebungen 
if(!function_exists('str_split')) {
	  function str_split($text, $split = 1) {
            $array = array();
           
            for ($i = 0; $i < strlen($text); $i += $split)
            {
                $array[] = substr($text, $i, $split);
            }
           
            return $array;
        }
} 
	
// konvertiert einen string in hexadezimale form 
function string2hex($string){
	// String in Einzelzeichen splitten
	$array = str_split($string);		
	
	// Einzelzeichen in HEX wandeln, '00' voranstellen und an string anhngen
	foreach ($array as $value) {
			$final .= "00" .bin2hex($value);			 
	}
	
	// HEX->Klein- in Grobuchstaben umwandeln			
	$final = strtoupper($final);
	
	return $final;
}


function generate_pdf($pdf_template, $pdf_form_values) {

	// Prfen, ob Fll-Werte hinterlegt sind
	if (!is_array($pdf_form_values)) {
		die ("Array \$pdf_form_values enthlt keine Werte.");
	}

	// Prfen, ob PDF-Template existiert
	if(!file_exists($pdf_template)){
		die ("kein pdf-template gefunden.");
	}	

	// Das PDF-Template ffnen
	if ($fp = fopen($pdf_template, 'rb')) {
    	 $template = fread ($fp, filesize ($pdf_template));
	     fclose ($fp);        
	} else {
		die ("pdf-template konnte nicht geffnet werden => ist evtl beschdigt.");
	}		

	// Aufbereiten der FELD-Lnge 
	reset($pdf_form_values);
	while (list($src, $dest) = each ($pdf_form_values)) {	
		// Vergleich Zeichenlnge ? ($dest darf nur kleiner o max gleichgro $src sein; keinesfalls grer) 
		if (strlen($dest) <= strlen($src)) { 					 		
				// Aufgefllten Wert ins array zurckschreiben		
				$pdf_form_values[$src] = str_pad($dest, strlen($src), " ", STR_PAD_RIGHT );
			} else { die("Ziel-String strlen($dest) lnger als Quellstring strlen($src)"); 
		}		 
	}		
	
	// Ersetzungen im Dokument vornehmen
	reset($pdf_form_values);
	while (list($key, $value) = each ($pdf_form_values)) {
		 // Prfen, ob Vorbelegungs-Wert im Template vorkommt
		 $treffer = substr_count($template, string2hex($key));		 
 		 if ($treffer == 0) { die("in PDF-Vorlage ist Vorbelegungswert $key nicht enthalten."); }
		 
		 // Ersetzen 
		 $template = str_replace(string2hex($key), string2hex($value), $template);		 
	}

	// aus Template wird Finale Datei
	$pdf = $template;
				
		
	// HTTP-Header ausgeben
	header("Content-type: application/octet-stream");
	header("Content-Disposition: attachment; filename=\"$pdf_template\"");
	header("Content-type: application/pdf");

	// das fertige PDF ausgeben
	echo $pdf; 
}  
?>